/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

/*
 * $Revision: 1.4 $
 *
 * Cache types and definetions
 */

#ifndef __mccacheinfo_h__
#define __mccacheinfo_h__ 

/*
 * Cache Information type
 */
typedef struct {
    int				Enabled;	/* Is this cache enabled? */
    int				Type;		/* Type of Cache */
    int				Level;		/* Level=1, 2, ... */
    Large_t			Size;		/* Size (bytes) */
    int				Speed;		/* Speed (ns) */
    int				Assoc;		/* Associativity */
    int				Lines;		/* # Lines */
    int				LineSize;	/* Line Size (bytes)*/
    int				TLB;		/* # TLB Entries */
    int				TLBAssoc;	/* # TLB Associativity */
    int				Socketed;	/* Is cache socketed? */
    char		       *Location;	/* Location relative to CPU */
    char		       *SramType;	/* SRAM Type */
    char		       *EccType;	/* ECC Type */
    char		       *Mode;		/* Mode (Write Back/Through..*/
} CacheInfo_t;

/*
 * Values for CacheInfo_t.Type
 */
#define CACHE_TYPE_INST		1		/* Instruction */
#define CACHE_TYPE_DATA		2		/* Data */
#define CACHE_TYPE_UNIFIED	3		/* Unified */

#endif	/* __mccacheinfo_h__ */
