#
# $Id: mcGeneral.pm,v 1.9 2002/03/09 01:05:10 mcooper Exp $
#
# SysInfo General class object
#

package mcGeneral;
require 5.003;

use mcMisc;
use mcDebug;

my $Descriptions =
	{
	 'Hostname'		=> {Desc=>'Host Name' },
	 'HostAliases'		=> {Desc=>'Host Aliases' },
	 'HostAddrs'		=> {Desc=>'Host Addresses' },
	 'HostId'		=> {Desc=>'Host ID' },
	 'Serial'		=> {Desc=>'Serial #' },
	 'ManShort'		=> {Desc=>'Manufacturer (Short)' },
	 'ManLong'		=> {Desc=>'Manufacturer (Long)' },
	 'Man'			=> {Desc=>'Manufacturer' },
	 'Model'		=> {Desc=>'Model' },
	 'PhysMem'		=> {Desc=>'Physical Memory' },
	 'VirtMem'		=> {Desc=>'Virtual Memory' },
	 'RomVer'		=> {Desc=>'ROM Version' },
	 'NumCpu'		=> {Desc=>'Number of CPU' },
	 'CpuType'		=> {Desc=>'CPU Type' },
	 'CpuSpeed'		=> {Desc=>'CPU Speed' },
	 'AppArch'		=> {Desc=>'App Architecture' },
	 'KernArch'		=> {Desc=>'Kernel Architecture' },
	 'KernBits'		=> {Desc=>'Kernel Bit Size' },
	 'OSname'		=> {Desc=>'OS Name' },
	 'OSver'		=> {Desc=>'OS Version' },
	 'OSdist'		=> {Desc=>'OS Distribution' },
	 'KernVer'		=> {Desc=>'Kernel Version' },
	 'BootTime'		=> {Desc=>'Boot Time' },
	 'CurrentTime'		=> {Desc=>'Current Time' },
	 'LibcName'		=> {Desc=>'Libc Name' },
	 'LibcVer'		=> {Desc=>'Libc Version' },
	 'Entries'		=> {NoShow=>1},
	};

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Hostname"} = undef;
    $self->{"HostAliases"} = [];
    $self->{"HostAddrs"} = [];
    $self->{"HostId"} = undef;
    $self->{"Serial"} = undef;
    $self->{"ManShort"} = undef;
    $self->{"ManLong"} = undef;
    $self->{"Man"} = undef;
    $self->{"Model"} = undef;
    $self->{"PhysMem"} = undef;
    $self->{"VirtMem"} = undef;
    $self->{"RomVer"} = undef;
    $self->{"NumCpu"} = undef;
    $self->{"CpuType"} = undef;
    $self->{"CpuSpeed"} = undef;
    $self->{"AppArch"} = undef;
    $self->{"KernArch"} = undef;
    $self->{"KernBits"} = undef;
    $self->{"OSname"} = undef;
    $self->{"OSver"} = undef;
    $self->{"OSdist"} = undef;
    $self->{"KernVer"} = undef;
    $self->{"BootTime"} = undef;
    $self->{"CurrentTime"} = undef;
    $self->{"LibcName"} = undef;
    $self->{"LibcVer"} = undef;
    $self->{"Entries"} = undef;

    $self->{"Desc"} = undef;

    bless ($self, $class);

    return $self;
}

sub Hostname {
    my $self = shift;

    if (!@_) {
	return $self->{"Hostname"};
    }

    $self->{"Hostname"} = shift;

    return;
}

sub HostAliases {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"HostAliases"} };
    }

    @{ $self->{"HostAliases"} } = @_;

    return;
}

sub HostAddrs {
    my $self = shift;

    if (!@_) {
	return @{ $self->{"HostAddrs"} };
    }

    @{ $self->{"HostAddrs"} } = @_;

    return;
}

sub HostId {
    my $self = shift;

    if (!@_) {
	return $self->{"HostId"};
    }

    $self->{"HostId"} = shift;

    return;
}

sub ManShort {
    my $self = shift;

    if (!@_) {
	return $self->{"ManShort"};
    }

    $self->{"ManShort"} = shift;

    return;
}

sub ManLong {
    my $self = shift;

    if (!@_) {
	return $self->{"ManLong"};
    }

    $self->{"ManLong"} = shift;

    return;
}

sub Man {
    my $self = shift;

    if (!@_) {
	return $self->{"Man"};
    }

    $self->{"Man"} = shift;

    return;
}

sub LibcName {
    my $self = shift;

    if (!@_) {
	return $self->{"LibcName"};
    }

    $self->{"LibcName"} = shift;

    return;
}

sub LibcVer {
    my $self = shift;

    if (!@_) {
	return $self->{"LibcVer"};
    }

    $self->{"LibcVer"} = shift;

    return;
}

sub Model {
    my $self = shift;

    if (!@_) {
	return $self->{"Model"};
    }

    $self->{"Model"} = shift;

    return;
}

sub PhysMem {
    my $self = shift;

    if (!@_) {
	return $self->{"PhysMem"};
    }

    $self->{"PhysMem"} = shift;

    return;
}

sub VirtMem {
    my $self = shift;

    if (!@_) {
	return $self->{"VirtMem"};
    }

    $self->{"VirtMem"} = shift;

    return;
}

sub RomVer {
    my $self = shift;

    if (!@_) {
	return $self->{"RomVer"};
    }

    $self->{"RomVer"} = shift;

    return;
}

sub NumCpu {
    my $self = shift;

    if (!@_) {
	return $self->{"NumCpu"};
    }

    $self->{"NumCpu"} = shift;

    return;
}

sub CpuType {
    my $self = shift;

    if (!@_) {
	return $self->{"CpuType"};
    }

    $self->{"CpuType"} = shift;

    return;
}

sub CpuSpeed {
    my $self = shift;

    if (!@_) {
	return $self->{"CpuSpeed"};
    }

    $self->{"CpuSpeed"} = shift;

    return;
}

sub AppArch {
    my $self = shift;

    if (!@_) {
	return $self->{"AppArch"};
    }

    $self->{"AppArch"} = shift;

    return;
}

sub KernArch {
    my $self = shift;

    if (!@_) {
	return $self->{"KernArch"};
    }

    $self->{"KernArch"} = shift;

    return;
}

sub KernBits {
    my $self = shift;

    if (!@_) {
	return $self->{"KernBits"};
    }

    $self->{"KernBits"} = shift;

    return;
}

sub OSname {
    my $self = shift;

    if (!@_) {
	return $self->{"OSname"};
    }

    $self->{"OSname"} = shift;

    return;
}

sub OSver {
    my $self = shift;

    if (!@_) {
	return $self->{"OSver"};
    }

    $self->{"OSver"} = shift;

    return;
}

sub OSdist {
    my $self = shift;

    if (!@_) {
	return $self->{"OSdist"};
    }

    $self->{"OSdist"} = shift;

    return;
}

sub KernVer {
    my $self = shift;

    if (!@_) {
	return $self->{"KernVer"};
    }

    $self->{"KernVer"} = shift;

    return;
}

sub BootTime {
    my $self = shift;

    if (!@_) {
	return $self->{"BootTime"};
    }

    $self->{"BootTime"} = shift;

    return;
}

sub CurrentTime {
    my $self = shift;

    if (!@_) {
	return $self->{"CurrentTime"};
    }

    $self->{"CurrentTime"} = shift;

    return;
}

sub Serial {
    my $self = shift;

    if (!@_) {
	return $self->{"Serial"};
    }

    $self->{"Serial"} = shift;

    return;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Fetch description
#
sub Desc {
    my $self = shift;
    my $Key = shift;

    if ($Descriptions->{$Key}->{'NoShow'}) {
	return;
    }

    return $Descriptions->{$Key}->{'Desc'};
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    my $k = $Fields[2];
    my $v = $Fields[4];

    my $EntryName = 'General';
    my $Entry = $self->New;
    # Lookup the entry (if any)
    my $e = $self->Entries($EntryName);
    if (!$e) {
	# Need a new object
	$e = $Entry;
    }

    #
    # We set both $e and $self to make it convienent for our caller
    # to use both General->$key and General->Entries->$key
    #

    if (Eq($k, 'hostname')) {
	$e->Hostname($v);
	$self->Hostname($v);
    } elsif (Eq($k, 'hostaliases')) {
	$e->HostAliases(split(',', $v));
	$self->HostAliases(split(',', $v));
    } elsif (Eq($k, 'hostaddrs')) {
	$e->HostAddrs(split(',', $v));
	$self->HostAddrs(split(',', $v));
    } elsif (Eq($k, 'hostid')) {
	$e->HostId($v);
	$self->HostId($v);
    } elsif (Eq($k, 'serial')) {
	$e->Serial($v);
	$self->Serial($v);
    } elsif (Eq($k, 'man')) {
	$e->Man($v);
	$self->Man($v);
    } elsif (Eq($k, 'manshort')) {
	$e->ManShort($v);
	$self->ManShort($v);
    } elsif (Eq($k, 'manlong')) {
	$e->ManLong($v);
	$self->ManLong($v);
    } elsif (Eq($k, 'model')) {
	$e->Model($v);
	$self->Model($v);
    } elsif (Eq($k, 'memory')) {
	$e->PhysMem($v);
	$self->PhysMem($v);
    } elsif (Eq($k, 'virtmem')) {
	$e->VirtMem($v);
	$self->VirtMem($v);
    } elsif (Eq($k, 'romver')) {
	$e->RomVer($v);
	$self->RomVer($v);
    } elsif (Eq($k, 'numcpu')) {
	$e->NumCpu($v);
	$self->NumCpu($v);
    } elsif (Eq($k, 'cpu')) {
	$e->CpuType($v);
	$self->CpuType($v);
    } elsif (Eq($k, 'cpuspeed')) {
	$e->CpuSpeed($v);
	$self->CpuSpeed($v);
    } elsif (Eq($k, 'arch')) {
	$e->AppArch($v);
	$self->AppArch($v);
    } elsif (Eq($k, 'karch')) {
	$e->KernArch($v);
	$self->KernArch($v);
    } elsif (Eq($k, 'kernbits')) {
	$e->KernBits($v);
	$self->KernBits($v);
    } elsif (Eq($k, 'osname')) {
	$e->OSname($v);
	$self->OSname($v);
    } elsif (Eq($k, 'osvers')) {
	$e->OSver($v);
	$self->OSver($v);
    } elsif (Eq($k, 'osdist')) {
	$e->OSdist($v);
	$self->OSdist($v);
    } elsif (Eq($k, 'kernver')) {
	$e->KernVer($v);
	$self->KernVer($v);
    } elsif (Eq($k, 'boottime')) {
	$e->BootTime($v);
	$self->BootTime($v);
    } elsif (Eq($k, 'currenttime')) {
	$e->CurrentTime($v);
	$self->CurrentTime($v);
    } elsif (Eq($k, 'libcname')) {
	$e->LibcName($v);
	$self->LibcName($v);
    } elsif (Eq($k, 'libcver')) {
	$e->LibcVer($v);
	$self->LibcVer($v);
    } else {
	Debug("General->Decode: Key <%s> is unknown.", $k);
    }

    # Add it back
    $self->Entries({$EntryName => $e});

    return $self;
}

1; # Make require/use happy
