#
# $Id: mcKernel.pm,v 1.2 2001/05/18 23:19:38 mcooper Exp $
#
# Kernel object
#

package mcKernel;
require 5.003;

use mcMisc;
use mcName;

#
# Object Constructor
#
sub New {
    my $proto = shift;
    my $class = ref($proto) || $proto;
    my $self = {};
    my $Err;

    $self->{"Entries"} = undef;

    bless ($self, $class);

    return $self;
}

sub Entries {
    my $self = shift;
    my $New;

    for my $Arg (@_) {
	if (ref($Arg) eq 'HASH') {
	    $New = $Arg;
	} else {
	    # Lookup and return result
	    return $self->{"Entries"}->{$Arg};
	}
    }

    if (!@_) {
	return $self->{"Entries"};
    }

    my $h = $self->{"Entries"};
    my @NewKey = keys %$New;
    my $NewVal = $New->{$NewKey[0]};
    $h->{$NewKey[0]} = $NewVal; # Overwrite old value
    $self->{"Entries"} = $h;

    return;
}

#
# Decode an array of general fields
#
sub Decode {
    my $self = shift;
    my @Fields = @_;

    if (!Eq($Fields[0], "kernel")) {
	return;
    }

    my $Name = $Fields[2];
    my $Entry = mcName->New;
    # Lookup the entry (if any)
    my $e = $self->Entries($Name);
    if (!$e) {
	# Need a new object
	$e = $Entry;
    }
    # Decode and Set
    $e->Decode(@Fields);
    # Add it back
    $self->Entries({$Name => $e});

    return $self;
}

1; # Make require/use happy
