/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

#include "defs.h"
#include "dmi.h"

static char		       *s = "Supports";
static DevDesc_t	      **lp;

/*
 * Decode DMI System Information (DMI_STRUCT_BOARD)
 */
extern DevInfo_t *DmiDecodeBoard(Hdr, Data, Dmi, Query)
     DmiHeader_t	       *Hdr;
     void		       *Data;
     Dmi_t		       *Dmi;
     DmiQuery_t		       *Query;
{
    DevInfo_t		       *DevInfo;
    DmiStructBoard_t	       *Sys;
    char		       *Mfg = NULL;
    char		       *Model = NULL;
    char		       *Version = NULL;
    char		       *Serial = NULL;
    char		       *cp;
    static char			Buff[128];
    static int			Unit;

    Sys = (DmiStructBoard_t *) Data;

    if ((cp = DmiString(Hdr, Sys->Mfg)) && !DmiIsGeneric(cp))
	Mfg = cp;
    if ((cp = DmiString(Hdr, Sys->Product)) && !DmiIsGeneric(cp))
	Model = cp;
    if ((cp = DmiString(Hdr, Sys->Version)) && !DmiIsGeneric(cp))
	Version = cp;
    if ((cp = DmiString(Hdr, Sys->Serial)) && !DmiIsGeneric(cp))
	Serial = cp;

    SImsg(SIM_DBG, "DMI BOARD: Mfg=<%s> Model=<%s> Version=<%s> Serial=<%s>",
	  PRTS(Mfg), PRTS(Model), PRTS(Version), PRTS(Serial));

    /*
     * If this is a specific query, then set the values now and return
     */
    if (Query && Query->Type == Hdr->Type) {
	Query->ValStr1 = Mfg;
	Query->ValStr2 = Model;
	Query->ValStr3 = Version;
	Query->ValStr4 = Serial;
	return DevInfo;
    }

    DevInfo = NewDevInfo(NULL);
    DevInfo->Unit = Unit++;
    snprintf(Buff, sizeof(Buff), "sysboard%d", DevInfo->Unit);
    DevInfo->Name = strdup(Buff);
    DevInfo->Type = DT_SYSBOARD;

    lp = &(DevInfo->DescList);

    if (Mfg)		DevInfo->Vendor = Mfg;
    if (Model)		DevInfo->Model = Model;
    if (Version)	DevInfo->Revision = Version;
    if (Serial)		DevInfo->Serial = Serial;

    return DevInfo;
}
