/*
 * Copyright (c) 1992-2003 MagniComp
 * This software may only be used in accordance with the license which is
 * available as http://www.magnicomp.com/sysinfo/4.2/sysinfo-eu-license.shtml
 */

#ifndef lint
static char *RCSid = "$Revision: 1.3 $";
#endif

#include "defs.h"
#include "dmi.h"

/*
 * Decode DMI System Config Info (DMI_STRUCT_SYSCONFIG)
 */
extern DevInfo_t *DmiDecodeSysconfig(Hdr, Data, Dmi, Query)
     DmiHeader_t	       *Hdr;
     void		       *Data;
     Dmi_t		       *Dmi;
     DmiQuery_t		       *Query;
{
    DevInfo_t		       *DevInfo = NULL;
    DevDesc_t		      **lp;
    DmiStructSysconfig_t       *Sysconfig;
    char		       *cp;
    register  int		i;

    Sysconfig = (DmiStructSysconfig_t *) Data;

    SImsg(SIM_DBG, 
	  "DMI SYSCONFIG: Handle=0x%04X Count=%d",
	  Hdr->Handle, Sysconfig->Count);
    SImsg(SIM_DBG, 
	  "DMI SYSCONFIG:\tsizeof(DmiStructSysconfig_t)=%d (0x%X) Hdr->Length=%d (0x%X)",
	  sizeof(DmiStructSysconfig_t), sizeof(DmiStructSysconfig_t), 
	  Hdr->Length, Hdr->Length);

    /*
     * If this is a specific query, then set the values now and return
     */
    if (Query && Query->Type == Hdr->Type) {
	/* Return nothing for now */
	return DevInfo;
    }

    /*
     * Just display for debug purposes until we know what to do with this data
     */
    for (i = 0; i < Sysconfig->Count; ++i) {
	if (cp = DmiString(Hdr, i+1))
	    SImsg(SIM_DBG, "DMI SYSCONFIG: String[%d]=<%s>", i+1, cp);
    }

#if 0
    DevInfo = NewDevInfo(NULL);
    DevInfo->Type = DT_GENERIC;
    lp = &(DevInfo->DescList);
#endif

    return DevInfo;
}
